package FLAnalyzer;
 
import ij.process.ImageProcessor;
import java.awt.Color;

/**  
 * Has a method 
 * for expanding images for box counting by adding a border.
 * @author Audrey Karperien
 * @since jdk 1.5.0_03
 * @version FracLac v2.4e
 * @version May 2006

 */
public class FLResizer
{
    
    /** Creates a new instance of Class */
    public FLResizer()
    {
    }    
    /****************************************************************/
    /**
     * Adds a border around an image
     * using ImageProcessor functions.
     * @return ipNew ImageProcessor with border
     * @param c Color for background
     * @param ipOld the ImageProcessor to act on
     * @param wNew double for new width
     * @param hNew double for new height
     * @param xOff double for offset from x coordinate
     * @param yOff double for offset from y coordinate
     */
    public static ImageProcessor 
            expandImage(ImageProcessor ipOld, 
    int wNew, 
    int hNew,
    int xOff, 
    int yOff,
    Color c
    ) {/*begin function to add border*/
        ImageProcessor ipNew = ipOld.createProcessor(wNew, hNew);        
        ipNew.setColor(c);       
        ipNew.fill();
        ipNew.insert(ipOld, xOff, yOff);
        return ipNew;
    }/*end add border*/
    
    
    
}
